const $ = require("jquery");
const ko = require("knockout");

const Dialog = require("cattura-ui-library/src/lib/ui/dialog");

const template = require("./content.pug");

let username = ko.observable().extend({
    required: true
});
let password = ko.observable();
let passwordConfirm = ko.observable().extend({
    equal: password
});
let emailAddress = ko.observable().extend({
    email: true
});

function makeDialog (plugin)
{
    return Dialog({
        open ()
        {
            this.show();
        },
        
        adminUser: ko.validatedObservable({
            username: username,
            password: password,
            passwordConfirm: passwordConfirm,
            emailAddress: emailAddress
        }),
        
        submit ()
        {
            if (!this.adminUser.isValid())
            {
                this.dispatchEvent({type: "error", message: "Please enter valid details for admin user."});
                return;
            }
            
            $.post("api/2/webSetupPlugin/setup", {
                adminUser:     username(),
                adminPassword: password(),
                adminEmail:    emailAddress() || null
            }).then(user => {
                if (!user)
                {
                    return;
                }
                
                location.reload();
            }).catch(error => this.dispatchEvent({type: "error", message: error.message}));
        }
    }, {
        easilyCloseable: false,
        template: template
    });
}

module.exports = makeDialog;
